DROP PROCEDURE IF EXISTS `ADD_ANONYMOUS`;

DELIMITER $$

CREATE PROCEDURE `ADD_ANONYMOUS`()
BEGIN
	DECLARE cursor_ID INT;
  	DECLARE done INT DEFAULT FALSE;
  	DECLARE cursor_i CURSOR FOR SELECT id FROM organizations;
  	DECLARE CONTINUE HANDLER FOR NOT FOUND SET done = TRUE;
  	OPEN cursor_i;
  	read_loop: LOOP
    	FETCH cursor_i INTO cursor_ID;
    	IF done THEN
      	LEAVE read_loop;
    	END IF;
    	IF NOT EXISTS 
	    (   
	    	SELECT  *
	        FROM    users 
	        WHERE   organizationId = cursor_ID
	     	AND 	email = 'anonymous@anonymous.com'
	    )
	    THEN
	        INSERT INTO `users`(`email`, `name`, `organizationId`, `organizationRole`) 
	        VALUES ('anonymous@anonymous.com', 'Anonymous User', cursor_ID, 'ROLE_ORGANIZATION_MEMBER');
            
            SET @last_user_id := LAST_INSERT_ID();
            
            INSERT INTO `user_details`(`userId`, `company`, `role`) 
	        VALUES (@last_user_id, 'TODO', 'ROLE_ANONYMOUS');
	    END IF;
  	END LOOP;
  	CLOSE cursor_i;
END
$$

DELIMITER ;

CALL ADD_ANONYMOUS();

DROP PROCEDURE IF EXISTS `ADD_ANONYMOUS`;