-- Insert a default platform admin if there is none already added 

DELIMITER //
CREATE PROCEDURE `ADD_DEFAULT_PLATFORM_ADMIN`()
BEGIN
DECLARE n INT DEFAULT 0;
DECLARE migrationType varchar(255);
	
	SELECT COUNT(*) FROM users JOIN user_details on users.userId = user_details.userId WHERE user_details.role = 'ROLE_APPLICATION_ADMIN' INTO n;
    SELECT type FROM flyway_schema_history WHERE installed_rank=1 INTO migrationType;
    IF n = 0 AND migrationType != 'SQL' THEN
		INSERT INTO `users`(`email`, `name`) VALUES ('feedback_php_default_platform_admin@example.com', '');
		INSERT INTO `user_details`(`userId`, `company`, `creationDate`, `role`) SELECT users.userId, '', CURRENT_TIMESTAMP, 'ROLE_APPLICATION_ADMIN' from users where users.email = 'feedback_php_default_platform_admin@example.com';
		
		SET @platformAdminId := (SELECT userId FROM users WHERE email='feedback_php_default_platform_admin@example.com');
		INSERT INTO `organizations`(`organizationId`, `name`,  ownerId, `contactEmail`) 
		VALUES ('feedback_php_organization', 'Feedback PHP Organization', @platformAdminId, 'feedback_php_default_platform_admin@example.com');
		
		SET @organizationId = (SELECT id FROM organizations WHERE organizationId='feedback_php_organization');
		UPDATE users SET organizationId=@organizationId, organizationRole='ROLE_ORGANIZATION_OWNER' WHERE userId=@platformAdminId;
	END IF;
	
END//
DELIMITER ;

-- Remove data from the tables that are not required for the enterprise distribution.
DELETE FROM edited_subscriptions_messages;
DELETE FROM corporate_subscription_page_views;
DELETE FROM avangate_subscriptions; 
DELETE FROM user_subscriptions; 

DELETE FROM user_subscription_notifications;
DELETE FROM subscription_history;

CALL ADD_DEFAULT_PLATFORM_ADMIN();

DROP PROCEDURE `ADD_DEFAULT_PLATFORM_ADMIN`;